/**********************************************************************
*
* FileName:        	delay_xlcd.c
* Processor:       	PIC18F
* 
*          - Delay routines:
*              - DelayFor18TCY() provides a 18 Tcy delay
*              - DelayPORXLCD() provides at least 15ms delay
*              - DelayXLCD() provides at least 5ms delay
*
***********************************************************************/
#include "xlcd.h"
#include <delays.h>

//Delay 18Tcy -> Delay at least 40 us
void DelayFor18TCY( void )
{
    unsigned char i = 30;
    while(i--);
 
}


//Delay at least 5 ms
void DelayXLCD (void)
{
  Delay1KTCYx(20); // Delay of 5ms
                   // Cycles = (TimeDelay * Fosc) / 4
                   // Cycles = (5ms * 16MHz) / 4
                   // Cycles = 20,000
  return;
}


//Delay at least 15 ms
void DelayPORXLCD (void)
{
  Delay1KTCYx(60); // Delay of 15ms
                   // Cycles = (TimeDelay * Fosc) / 4
                   // Cycles = (15ms * 16MHz) / 4
                   // Cycles = 60,000
  return;
}