/*
 * File:   main.c
 * Author: Sarunas Kilius
 * Programa: LCD tekstas
 * Mikrovaldiklis: PIC18F24K22
 * Daznis: 16 MHz
 *
 */

/** INCLUDES **********************/
#undef _PLIB          //neitraukti biblioteku is XC8 direktorijos
#include <xc.h>
#include "xlcd.h"     //itraukti xlcd is projekto direktorijos
//#include <plib.h>   //reikia, jei naudojamos ir kitos bibliotekos

/** CONFIGURATION *****************/
#pragma config FOSC = INTIO67       //Internal oscillator
#pragma config WDTEN = OFF          //Watch dog timer disabled
#pragma config LVP = OFF            //LVP Off


void main(void) {

    char Disp_1[] = " Sveiki,         ";
    char Disp_2[] = " tai LCD tekstas ";

    OSCCONbits.IRCF2 = 1;	//Vidinis RC rezonatorius
    OSCCONbits.IRCF1 = 1;	//nustatomas 16MHz
    OSCCONbits.IRCF0 = 1;
    
    ANSELA = 0;
    ANSELB = 0;
    ANSELC = 0;

    LATA = 0;
    TRISA = 0;                  //PORTA - isejimai
    LATB = 0;
    TRISB = 0;                  //PORTB - isejimai
    LATC = 0;
    TRISC = 0;                  //PORTC - isejimai

    //LCD nustatymai
  OpenXLCD( FOUR_BIT & LINES_5X7 );

   //Teksto atvaizdavimas LCD
    SetDDRamAddr(0x80);         //1-os eilutes adresas
        while( BusyXLCD() );

    putsXLCD(Disp_1);           //1-os eilutes tekstas
        while( BusyXLCD() );

    SetDDRamAddr(0xC0);		//2-os eilutes adresas
        while( BusyXLCD() );

    putsXLCD(Disp_2);           //2-os eilutes tekstas
        while( BusyXLCD() );

    while(1)
    {
  
    }
}
