/*
 * File:   main2.c
 * Author: Sarunas Kilius
 * Programa: LCD skaiciai
 * Mikrovaldiklis: PIC18F24K22
 * Daznis: 16 MHz
 *
 */

/** INCLUDES **********************/
#undef _PLIB          //neitraukti biblioteku is XC8 direktorijos
#include <xc.h>
#include "xlcd.h"     //itraukti xlcd is projekto direktorijos
//#include <plib.h>   //reikia, jei naudojamos ir kitos bibliotekos
#include <stdlib.h>   //itoa funkcijai

/** CONFIGURATION *****************/
#pragma config FOSC = INTIO67       //Internal oscillator
#pragma config WDTEN = OFF          //Watch dog timer disabled
#pragma config LVP = OFF            //LVP Off


void main(void) {

    char buffer[16];                //masyvas skaiciams
    float i = 1234.56;
 
    OSCCONbits.IRCF2 = 1;	//Vidinis RC rezonatorius
    OSCCONbits.IRCF1 = 1;	//nustatomas 16MHz
    OSCCONbits.IRCF0 = 1;

    ANSELA = 0;
    ANSELB = 0;
    ANSELC = 0;

    LATA = 0;
    TRISA = 0;                  //PORTA - isejimai
    LATB = 0;
    TRISB = 0;                  //PORTB - isejimai
    LATC = 0;
    TRISC = 0;                  //PORTC - isejimai

    //LCD nustatymai
  OpenXLCD( FOUR_BIT & LINES_5X7 );

   //Teksto atvaizdavimas LCD
    SetDDRamAddr(0x80);         //1-os eilutes adresas
        while( BusyXLCD() );

    putrsXLCD("Float skaicius");           //1-os eilutes tekstas
        while( BusyXLCD() );

    SetDDRamAddr(0xC0);		//2-os eilutes adresas
        while( BusyXLCD() );

    //Skaiciaus sveika dalis
    itoa(buffer, (int)i, 10);   //konvertuojame sveika dali
    putsXLCD(buffer);           //atvaizduojame sveika dali
        while( BusyXLCD() );

    //Skaiciaus trupmenine dalis
    //Patikriname ar yra ir tik tuomet atvaizduojame
    if((int)((i-(int)i)*100))
    {
        putrsXLCD(",");		//atvaizduojame kableli
            while( BusyXLCD() );

        itoa(buffer, (int)((i-(int)i)*100), 10); //trupmenine dalis
        putsXLCD(buffer);
            while( BusyXLCD() );
    }

    while(1)
    {

    }
}
